<template>
  <el-button type="primary" round @click="onReferYourFriend" class="bk8-btn">{{
    $t("refer_your_friend")
  }}</el-button>
  <el-dialog
    v-model="isQRDialogVisable"
    custom-class="bg-transparent qr-dialog-background flex flex-col items-center justify-center dialog-ref"
    fullscreen
    destroy-on-close
  >
    <div :class="themeColor.Text === 'bk8' && ' bd-rd bg-white'">
      <div class="py-[8px] px-[12px] flex justify-between bg-background1 rounded-tl-md bd-rd-top" v-if="themeColor.Text === 'bk8'" >
        <p class="font-bold">{{ $t('refer') }}</p> 
        <div @click="onReferToFriendDialogClose"><img
          :src="
            getAssetImage(
              'assets/referral/cancel.png'
            )
          "
          alt=""
        /></div>
      </div>
      <div class="flex items-center justify-center py-3">
        <h6 :class="themeColor.Text === 'bk8' ? 'fc-text' : 'fc-hint'">
          {{ $t("refer_your_friend_to_get_more_reward") }}
        </h6>
      </div>
      <div class="p-5 rounded-lg bg-white flex justify-center items-center" :class="themeColor.Text === 'bk8' ? 'w-full' : 'w-fit'">
        <qrcode-vue
          id="qrCode"
          class="p-0"
          value="https://www.google.com"
          size="200"
        ></qrcode-vue>
      </div>
      <div class="flex items-center justify-center py-4" v-if="themeColor.Text === 'bk8'">
        <div>
          <div class="bg-primary py-[10px] px-[12px] rounded-[20px] flex mb-4 w-[200px] justify-center items-center"  @click="onCopyQRCode">
            <div class="mr-2">
              <img
                :src="
                  getAssetImage(
                    'assets/referral/Download.png'
                  )
                "
                alt=""
              />
            </div>
            <div class="fc-textBtn">{{ $t('download') }}</div>
          </div>
          <div class="bg-primary py-[10px] px-[12px] rounded-[20px] flex w-[200px] justify-center items-center"  @click="onCopyTextToClipBoard">
            <div class="mr-2">
              <img
                :src="
                  getAssetImage(
                    'assets/referral/iconcopy.png'
                  )
                "
                alt=""
              />
            </div>
            <div class="fc-textBtn">{{ $t('copy_link') }}</div>
          </div>
        </div>   
      </div>
      <div class="flex items-center justify-center py-4" v-else>
        <el-button
          class="flex flex-col w-fit mx-6"
          icon="Download"
          circle
          @click="onCopyQRCode"
        />
        <el-button
          class="flex flex-col w-fit mx-6"
          round
          icon="Share"
          circle
          @click="onCopyTextToClipBoard"
        />
      </div>
    </div>
  </el-dialog>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";
import QrcodeVue from "qrcode.vue";

export default defineComponent({
  components: {
    QrcodeVue,
  },
  setup() {
    const {
      referralLink,
      onCopyTextToClipBoard,
      onCopyQRCode,
    } = useReferral();
    const { getAssetImage } = commonHelper;
    const { themeColor } = themePropertyHelper;
    const isQRDialogVisable = ref(false);
    const onReferYourFriend = () => {
      isQRDialogVisable.value = true;
    };
    const onReferToFriendDialogClose = () => {
      isQRDialogVisable.value = false;
    };
    return {
      referralLink,
      isQRDialogVisable,
      onReferYourFriend,
      onCopyTextToClipBoard,
      onCopyQRCode,
      themeColor,
      getAssetImage,
      onReferToFriendDialogClose
    };
  },
});
</script>
<style lang="postcss" scoped>
[theme-color="bk8"] .bk8-btn {
  width: 206px !important;
  height: 40px !important;
}
.bd-rd-top {
  border-top-left-radius: 10px;
  border-top-right-radius: 10px;
}

.bd-rd {
  border-radius: 10px;
}

</style>
<style>div.common-main[theme-color='bk8'] .dialog-ref button[aria-label='Close this dialog'] {
  display: none;
}

div.common-main[theme-color='bk8'] .dialog-ref .el-dialog__body {
  width: 100%;
}</style>